关闭

C++ 异常处理

标签: 异常处理
714人阅读 评论(0) 收藏 举报
分类:
  • 程序常见的错误
    • 语法错误/编译错误:比如关键字拼写错误,变量名未定义,语句末尾缺少分好,括号不匹配,不能找到头文件......
    • 运行错误/:程序在运行过程中出现错误:例如除数为零,访问地址非法,输入数据有误......
  • 异常处理的方法
    • 如果执行一个函数过程中出现异常,如果本函数没有异常处理,就逐级向上抛出一个异常信息。最高一级也无法处理,最后异常终止程序执行。
    • 异常处理中的三分部分:
      • 检查:try
      • 抛出:throw
      • 捕获:catch
    • 异常处理的形式:
      • try-catch结构
        • try
        •     {被检查的语句或者函数}
        • catch (异常信息类型 [变量名])  // 变量为可选,用来接受抛出的数据
        •     {进行异常处理的语句}
      • throw语句:
        • throw 数据;  // 放在被检查的语句或者函数中
      • 注意
        • 被检查的语句和函数必须放在try模块中
        • try和catch作为一个整体出现,中间不能插入其他语句
        • try和catch模块必须用花括号括起来
        • 一个try-catch结构可以直邮一个try模块,单可以有多个catch模块
        • catch(...):代表捕获类型未指定,它可以捕获任何类型的异常信息
        • “throw;” 表示"当前try语句不出了这个异常,请上级处理",例如
          • try 
          • {
          •     throw double(2.0);
          • }
          • catch (double)
          • {
          •     throw;
          •     cout << "This sentence will not be printed out!" << endl;
          • }
        • 如果throw抛出的语句找不到与之匹配的catch模块,那么系统就会调用terminate函数终止程序。
  • 在函数声明中进行异常情况指定
    • 为了便于阅读,在声明函数时列出可能抛出的异常情况:
      • double triangle(double, double, double) throw(double);
      • double triangle(double, double, double) throw(int, double, float, char);  // 表示可以抛出四种类型的异常
      • double triangle(double, double, double) throw();  // 声明一个不抛出异常的函数,即使函数内有throw语句也不执行。
  • 在异常处理中处理析构函数
    • 在执行try模块过程中发生异常,成员会离开try模块(如果try模块中调用函数,则程序先离开该函数,回到try模块),这样有可能离开该对象的作用于而转到其他函数,因而应当事先做好结束对象前的清理工作。
  • 举例:
    #include <strstream>
    #include <iostream>
    #include <stack>
    using namespace std;
    
    int main()
    {
        void f1();
    
        try
        {
            f1();
        }
        catch(double)
        {
            cout << "OK0" << endl;
        }
        cout << "end0" << endl;
        return 0;
    }
    
    void f1()
    {
        void f2();
        try{f2();}
        catch(char)
        {
            cout << "OK1" << endl;
        }
        cout << "end1" << endl;
    }
    
    void f2()
    {
        void f3();
        try{f3();}
        catch(int)
        {
            cout << "OK2" << endl;
        }
        cout << "end2" << endl;
    }
    
    void f3()
    {
        double a = 0;
        try
        {
            throw a;
        }
        catch (float)       // 结果OK0 end0
    //    catch (double)    // OK3 end3 end2 end1 end0
        {
            cout << "OK3" << endl;
    //        throw;    // 将a直接抛出,最后结果 OK3 OK0 end0
        }
        cout << "end3" << endl;
    }
0
0

查看评论
* 以上用户言论只代表其个人观点,不代表CSDN网站的观点或立场
    个人资料
    • 访问:100842次
    • 积分:2098
    • 等级:
    • 排名:第18253名
    • 原创:95篇
    • 转载:86篇
    • 译文:0篇
    • 评论:0条